package org.seasar.doma.it.entity;

/** */
@javax.annotation.Generated(value = { "Doma", "1.36.0-SNAPSHOT" }, date = "2022-09-08T03:50:33.595+0900")
public final class _CompKeyDepartment extends org.seasar.doma.jdbc.entity.AbstractEntityType<org.seasar.doma.it.entity.CompKeyDepartment> {

    static {
        org.seasar.doma.internal.Artifact.validateVersion("1.36.0-SNAPSHOT");
    }

    private static final _CompKeyDepartment __singleton = new _CompKeyDepartment();

    private static final org.seasar.doma.jdbc.entity.OriginalStatesAccessor<org.seasar.doma.it.entity.CompKeyDepartment> __originalStatesAccessor = new org.seasar.doma.jdbc.entity.OriginalStatesAccessor<org.seasar.doma.it.entity.CompKeyDepartment>(org.seasar.doma.it.entity.CompKeyDepartment.class, "originalStates");

    /** the departmentId1 */
    public final org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object> $departmentId1 = new org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "departmentId1", "DEPARTMENT_ID1");

    /** the departmentId2 */
    public final org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object> $departmentId2 = new org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "departmentId2", "DEPARTMENT_ID2");

    /** the departmentNo */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object> $departmentNo = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "departmentNo", "DEPARTMENT_NO", true, true);

    /** the departmentName */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.String, java.lang.Object> $departmentName = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.String, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.String.class, org.seasar.doma.wrapper.StringWrapper.class, null, null, "departmentName", "DEPARTMENT_NAME", true, true);

    /** the location */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.String, java.lang.Object> $location = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.String, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.String.class, org.seasar.doma.wrapper.StringWrapper.class, null, null, "location", "LOCATION", true, true);

    /** the version */
    public final org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object> $version = new org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.CompKeyDepartment.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "version", "VERSION");

    private final org.seasar.doma.jdbc.entity.NullEntityListener<org.seasar.doma.it.entity.CompKeyDepartment> __listener;

    private final org.seasar.doma.jdbc.entity.NamingType __namingType;

    private final boolean __immutable;

    private final String __catalogName;

    private final String __schemaName;

    private final String __tableName;

    private final String __qualifiedTableName;

    private final String __name;

    private final java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __idPropertyTypes;

    private final java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __entityPropertyTypes;

    private final java.util.Map<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __entityPropertyTypeMap;

    private _CompKeyDepartment() {
        __listener = new org.seasar.doma.jdbc.entity.NullEntityListener<org.seasar.doma.it.entity.CompKeyDepartment>();
        __namingType = org.seasar.doma.jdbc.entity.NamingType.SNAKE_UPPER_CASE;
        __immutable = false;
        __name = "CompKeyDepartment";
        __catalogName = "";
        __schemaName = "";
        __tableName = "COMP_KEY_DEPARTMENT";
        __qualifiedTableName = "COMP_KEY_DEPARTMENT";
        java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __idList = new java.util.ArrayList<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>>();
        java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __list = new java.util.ArrayList<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>>(6);
        java.util.Map<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> __map = new java.util.HashMap<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>>(6);
        __idList.add($departmentId1);
        __list.add($departmentId1);
        __map.put("departmentId1", $departmentId1);
        __idList.add($departmentId2);
        __list.add($departmentId2);
        __map.put("departmentId2", $departmentId2);
        __list.add($departmentNo);
        __map.put("departmentNo", $departmentNo);
        __list.add($departmentName);
        __map.put("departmentName", $departmentName);
        __list.add($location);
        __map.put("location", $location);
        __list.add($version);
        __map.put("version", $version);
        __idPropertyTypes = java.util.Collections.unmodifiableList(__idList);
        __entityPropertyTypes = java.util.Collections.unmodifiableList(__list);
        __entityPropertyTypeMap = java.util.Collections.unmodifiableMap(__map);
    }

    @Override
    public org.seasar.doma.jdbc.entity.NamingType getNamingType() {
        return __namingType;
    }

    @Override
    public boolean isImmutable() {
        return __immutable;
    }

    @Override
    public String getName() {
        return __name;
    }

    @Override
    public String getCatalogName() {
        return __catalogName;
    }

    @Override
    public String getSchemaName() {
        return __schemaName;
    }

    @Override
    public String getTableName() {
        return __tableName;
    }

    @Override
    public String getQualifiedTableName() {
        return __qualifiedTableName;
    }

    @Override
    public void preInsert(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PreInsertContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.preInsert(entity, context);
    }

    @Override
    public void preUpdate(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PreUpdateContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.preUpdate(entity, context);
    }

    @Override
    public void preDelete(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PreDeleteContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.preDelete(entity, context);
    }

    @Override
    public void postInsert(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PostInsertContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.postInsert(entity, context);
    }

    @Override
    public void postUpdate(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PostUpdateContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.postUpdate(entity, context);
    }

    @Override
    public void postDelete(org.seasar.doma.it.entity.CompKeyDepartment entity, org.seasar.doma.jdbc.entity.PostDeleteContext<org.seasar.doma.it.entity.CompKeyDepartment> context) {
        __listener.postDelete(entity, context);
    }

    @Override
    public java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> getEntityPropertyTypes() {
        return __entityPropertyTypes;
    }

    @Override
    public org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?> getEntityPropertyType(String __name) {
        return __entityPropertyTypeMap.get(__name);
    }

    @Override
    public java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.CompKeyDepartment, ?>> getIdPropertyTypes() {
        return __idPropertyTypes;
    }

    @Override
    public org.seasar.doma.jdbc.entity.GeneratedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, ?, ?> getGeneratedIdPropertyType() {
        return null;
    }

    @Override
    public org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.CompKeyDepartment, ?, ?> getVersionPropertyType() {
        return $version;
    }

    @Override
    public org.seasar.doma.it.entity.CompKeyDepartment newEntity() {
        return new org.seasar.doma.it.entity.CompKeyDepartment();
    }

    @Override
    public org.seasar.doma.it.entity.CompKeyDepartment newEntity(java.util.Map<String, Object> __args) {
        return new org.seasar.doma.it.entity.CompKeyDepartment();
    }

    @Override
    public Class<org.seasar.doma.it.entity.CompKeyDepartment> getEntityClass() {
        return org.seasar.doma.it.entity.CompKeyDepartment.class;
    }

    @Override
    public org.seasar.doma.it.entity.CompKeyDepartment getOriginalStates(org.seasar.doma.it.entity.CompKeyDepartment __entity) {
        return __originalStatesAccessor.get(__entity);
    }

    @Override
    public void saveCurrentStates(org.seasar.doma.it.entity.CompKeyDepartment __entity) {
        org.seasar.doma.it.entity.CompKeyDepartment __currentStates = new org.seasar.doma.it.entity.CompKeyDepartment();
        $departmentId1.getWrapper(__currentStates).set($departmentId1.getWrapper(__entity).getCopy());
        $departmentId2.getWrapper(__currentStates).set($departmentId2.getWrapper(__entity).getCopy());
        $departmentNo.getWrapper(__currentStates).set($departmentNo.getWrapper(__entity).getCopy());
        $departmentName.getWrapper(__currentStates).set($departmentName.getWrapper(__entity).getCopy());
        $location.getWrapper(__currentStates).set($location.getWrapper(__entity).getCopy());
        $version.getWrapper(__currentStates).set($version.getWrapper(__entity).getCopy());
        __originalStatesAccessor.set(__entity, __currentStates);
    }

    /**
     * @return the singleton
     */
    public static _CompKeyDepartment getSingletonInternal() {
        return __singleton;
    }

    /**
     * @return the new instance
     */
    public static _CompKeyDepartment newInstance() {
        return new _CompKeyDepartment();
    }

}
